#define WIN32_LEAN_AND_MEAN
#include <winsock2.h>

#include <Ws2tcpip.h.>
#include <Ws2spi.h>

#include <iphlpapi.h>
#include <process.h>
#include <errno.h>
#include <stdlib.h>
#include "portable.h"


void displayError(int errCode)
{
	static char Message[1024];
	printf("Error %d:",errCode);
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS |
                  FORMAT_MESSAGE_MAX_WIDTH_MASK,
                  NULL, errCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPSTR)Message, 1024, NULL);
	printf("%s\n",Message);
}

extern int sock_add(char * ifacename,int ifaceid, char * addr, int port, int thisifaceonly)
{
	ADDRINFO			info;
	ADDRINFO			*local;
	char				ifaceStr[10];
	char				portStr[10];
	struct in6_addr		*packed;
	char				addrStr[sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255")+5];
	SOCKET				s;
	struct ipv6_mreq	ipmreq; 
	int					hops=8;		
	char				addrpack[16];
//	int					err;
	struct sockaddr_in6 *addrpck;
	itoa(port,portStr,10);
	itoa(ifaceid,ifaceStr,10);
	inet_pton6(addr,addrpack);

	packed=(struct in6_addr*)addrpack;
	strcpy(addrStr,addr);

	if(IN6_IS_ADDR_LINKLOCAL(packed)||IN6_IS_ADDR_SITELOCAL(packed))
		strcat(strcat(addrStr,"%"),ifaceStr);

	memset(&info, 0, sizeof(info));
	info.ai_flags=AI_PASSIVE|AI_NUMERICHOST;
	info.ai_family=PF_INET6;
	info.ai_socktype=SOCK_DGRAM;

	
	if (IN6_IS_ADDR_MULTICAST(packed))
	{
		if(getaddrinfo(NULL,portStr,&info,&local)) 
			return -1;
	}
	else
		if(getaddrinfo(addrStr,portStr,&info,&local)) 
			return -1;
 
	 addrpck=(struct sockaddr_in6*)(local->ai_addr);
	if ((s=socket(local->ai_family,local->ai_socktype,local->ai_protocol))
			==INVALID_SOCKET)
		return -2;
	
	
	if (bind(s,local->ai_addr,local->ai_addrlen))
    {
		displayError(WSAGetLastError());
		return -3;
    }



	if (IN6_IS_ADDR_MULTICAST((IN6_ADDR*)addrpack))
	{
		ipmreq.ipv6mr_interface=ifaceid;
		memcpy(&ipmreq.ipv6mr_multiaddr,addrpack,16);
		if(setsockopt(s,IPPROTO_IPV6,IPV6_ADD_MEMBERSHIP,(char*)&ipmreq,sizeof(ipmreq)))
			return -4;
//			displayError(WSAGetLastError());
		if(setsockopt(s,IPPROTO_IPV6,IPV6_MULTICAST_HOPS,(char*)&hops,sizeof(hops)))
			return -5;
//			displayError(WSAGetLastError());
	}
	freeaddrinfo(local);
	return s;
}

extern int sock_del(int fd)
{
	return closesocket(fd);
}
extern int sock_send(int fd, char * addr, char * buf, int buflen, int port,int iface)
{	
//	struct ipv6_mreq	ipmreq; 
	ADDRINFO			inforemote,*remote;
	char				addrStr[sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255")+5];
	char				portStr[10];
	int i;
	char				packaddr[16];
	char				ifaceStr[10];

	strcpy(addrStr,addr);
	itoa(port,portStr,10);
    itoa(iface,ifaceStr,10);
	inet_pton6(addrStr,packaddr);

    if(IN6_IS_ADDR_LINKLOCAL(packaddr)||IN6_IS_ADDR_SITELOCAL(packaddr))
		strcat(strcat(addrStr,"%"),ifaceStr);
/*	if (IN6_IS_ADDR_MULTICAST((IN6_ADDR*)addr))
	{
		ipmreq.ipv6mr_interface=4;
		memcpy(&ipmreq.ipv6mr_multiaddr,addr,16);
		if(setsockopt(fd,IPPROTO_IPV6,IPV6_ADD_MEMBERSHIP,(char*)&ipmreq,sizeof(ipmreq)))
			return -1; //WSAGetLastError();
		//int hops=8;
		//if(setsockopt(fd,IPPROTO_IPV6,IPV6_MULTICAST_HOPS,(char*)&hops,sizeof(hops)))
		//	return -1; //WSAGetLastError();
	}*/
	
	memset(&inforemote, 0, sizeof(inforemote));
	inforemote.ai_flags=AI_NUMERICHOST;
	inforemote.ai_family=PF_INET6;
	inforemote.ai_socktype=SOCK_DGRAM;
	inforemote.ai_protocol=IPPROTO_IPV6;
	//inet_ntop6(addr,addrStr);
	if(getaddrinfo(addrStr,portStr,&inforemote,&remote))
		return 0;
	if (i=sendto(fd,buf,buflen,0,remote->ai_addr,remote->ai_addrlen))
	{
		freeaddrinfo(remote);
    	if (i<0) displayError(WSAGetLastError());
		return 0;
	}
/*	if((setsockopt(fd,IPPROTO_IPV6,IPV6_DROP_MEMBERSHIP,(char*)&ipmreq,sizeof(ipmreq))))
		return WSAGetLastError();*/
	freeaddrinfo(remote);
	return i;
}
extern int sock_recv(int fd, char * addr, char * buf, int buflen)
{
	SOCKADDR_IN6	info;  
	int				infolen;		
	int				readBytes;
	
	infolen=sizeof(info);
	if(!(readBytes=recvfrom(fd,buf,buflen,0,(SOCKADDR*)&info,&infolen)))
		return -1;
	else
	{
		inet_ntop6(info.sin6_addr.u.Byte,addr);
		return	readBytes;
	}
} 
